import { PureComponent } from 'react';
import { TAB_KEY } from '../../config';
import { FunctionEventParams } from '../../types';
import { IEditorInstance, IMonacoInstance } from '@gant-lowcode/lowcode-plugin-base-monaco-editor/lib/helper';
import { HookAPI } from 'antd/es/modal/useModal';
import './JsEditor.css';
interface JsEditorProps {
    jsCode: string;
    editor: any;
    currentTab: TAB_KEY;
    setChanged: (changed: boolean) => void;
    modal: HookAPI;
}
interface JsEditorState {
    state?: Record<string, any>;
    hasError: boolean;
    errorInfo?: string | null;
    code?: string;
    errorLocation?: {
        line: number;
        column: number;
    };
}
export declare class JsEditor extends PureComponent<JsEditorProps, JsEditorState> {
    state: JsEditorState;
    monaco?: IMonacoInstance;
    monacoEditor?: IEditorInstance;
    lastErrorDecoration: any;
    disposeProvider?: {
        dispose: () => void;
    };
    getSchemaFromCode(): {
        statements: any[];
        originCode: any;
    };
    editorDidMount: (monaco: IMonacoInstance, editor: IEditorInstance) => Promise<void>;
    focusByFunctionName({ functionName }: FunctionEventParams): void;
    addFunction(params: FunctionEventParams): void;
    render(): JSX.Element;
    _updateCode: (newCode: string) => void;
}
export {};
