"use strict";

exports.__esModule = true;
exports.transformJS = void 0;
var _babel = require("./babel");
var transformJS = exports.transformJS = function transformJS(code, config) {
  var hasError = false;
  var errorInfo = '';
  var transformCode = '';
  var errorLocation = undefined;
  try {
    transformCode = (0, _babel.transform)(code, config).code;
  } catch (ex) {
    var _ex$message$split$, _ex$message, _ex$message$split;
    hasError = true;
    console.error(ex);
    errorInfo = (_ex$message$split$ = (_ex$message = ex.message) === null || _ex$message === void 0 ? void 0 : (_ex$message$split = _ex$message.split('\n')) === null || _ex$message$split === void 0 ? void 0 : _ex$message$split[0]) !== null && _ex$message$split$ !== void 0 ? _ex$message$split$ : '代码解析异常';
    errorInfo = errorInfo.replace('unknown: ', '');
    errorLocation = ex.loc;
  }
  return {
    hasError: hasError,
    errorInfo: errorInfo,
    errorLocation: errorLocation,
    code: transformCode
  };
};